#!/usr/bin/env node

var program = require('commander');
const chalk = require('chalk');
const path = require('path');
const fs = require('fs');
const rootPath = process.cwd();
const util = require('../libs/util.js');
program.version(require('../package').version);

// 设置选项，boolean类型的选项，不携带参数
program.option('-v| --version', '显示版本信息');

// 处理参数
program.parse(process.argv);

// 不处理的文件列表
let noKeep = ["node_modules",".svn",".git","unpackage"];
const gitignoreContent = [];
try {
	gitignoreContent = fs.readFileSync('./.gitignore', 'utf-8').split("\n").map(num=>num.trim());
} catch (error) {
	
}
noKeep = noKeep.concat(gitignoreContent)

fileDisplay(rootPath)

//文件遍历方法
function fileDisplay(filePath) {
	let dirName = path.basename(filePath);
	let isKeep = true;
	noKeep.map(num=>{
		let zz = new RegExp(num);
		if(zz.test(dirName)){
			isKeep = false;
		}
	})
	if(!isKeep){
		console.log(
			`${util.getTime()} `+
			`${getHex("ms","检测到不处理文件夹：")}${getHex("file",filePath)}${getHex("ms","，已跳过")}`
		);
		return false;
	}
  fs.readdir(filePath,(err,datas)=>{
		if(err){
			console.log(err);
		}else{
			if(datas.length){
				let hegeFile = 0;
				datas.forEach(function(filename,index) {
					//获取当前文件的绝对路径
					var filedir = path.join(filePath, filename);
					//根据文件路径获取文件信息，返回一个fs.Stats对象
					let indexs = index;
					fs.stat(filedir,(err,stats)=>{
						var isFile = stats.isFile(); //是文件
						var isDir = stats.isDirectory(); //是文件夹
						if (isDir) {
							let ishege = fileDisplay(filedir); //递归，如果是文件夹，就继续遍历该文件夹下面的文件
							if(ishege){
								hegeFile ++;
							}
						}else{
							hegeFile ++;
						}
					})
				})
				// if(!hegeFile){
				// 	addKeepFile(filePath);
				// }
			}else{
				addKeepFile(filePath);
			}
		}
		return true;
  });
}

// 添加keep文件
function addKeepFile(filePath){
	fs.writeFile(path.join(filePath,".gitkeep"),"",'utf-8',()=>{
		console.log(
			`${util.getTime()} `+
			`${getHex("ms","检测到空文件夹")}${getHex("file",filePath)}${getHex("ms","，.gitkeep文件已添加")}`
		);
	});
}

//获取hex
function getHex(type,str){
	let fontColor={ms:"#FF8000",add:"#0fc558",delete:"#c51832",file:"#c1a766"};
  return chalk.hex(fontColor[type]).bold(str);
}
