#!/usr/bin/env node

const vueLoader = require('../libs/vue-loader.js')
var program = require('commander');
var lodash = require('lodash');
const chalk = require('chalk');
const ora = require('ora');
const spinnerstyle = require('../libs/spinners.json');
const util = require('../libs/util.js');
const path = require('path');
const fs = require('fs');
const rootPath = process.cwd();
// const rootPath = "C:\\Users\\admin\\Desktop\\views";
const spinner = ora({//growHorizontal、noise、triangle、bouncingBar、point
  spinner:spinnerstyle.bouncingBar2,
  color:"green"
});
let fontColor={ms:"#FF8000",add:"#0fc558",delete:"#c51832",file:"#c1a766"};
program.version(require('../package').version);

// 设置选项，boolean类型的选项，不携带参数
program.option('-v| --version', '显示版本信息');

// 处理参数
program.parse(process.argv);

let zongFileList = [];  //总的文件配置
let newZongList = []; //变化后的文件配置
let addZongList = []; //变化后的新增文件配置
let deleteZongList = []; //变化后的删除文件配置

addFileEvent(rootPath);
checkProjeck(rootPath,true);
// setInterval(()=>{
//   checkProjeck(rootPath)
// },3*1000)
//开启检查模式
function checkProjeck (rootPath,isChuci) {
  newZongList = [];
  addZongList = [];
  deleteZongList = [];
  let setTimeonj = null;
  let backFun = ()=>{
    if(setTimeonj)clearTimeout(setTimeonj);
    setTimeonj = setTimeout(()=>{
      if(!isChuci)spinner.stop();
      let backDuibi = (strs)=>{
        if(isChuci){
          spinner.text = strs;
        }else{
          console.log(strs)
        }
      }
      duibiFiles(backDuibi);
      spinner.stop();
      let addnumber = addZongList.length;
      let removenumber = deleteZongList.length;
      let consoles = getHex("ms","检查完毕，共检测出");
      if(removenumber || addnumber){
        if(addnumber){
          consoles+=getHex("add"," 新增："+addnumber)
        }
        if(removenumber){
          consoles+=getHex("delete"," 删除："+removenumber)
        }
        console.log(util.getTime() + " " + consoles);
        if(isChuci)spinner.start();
        createComAllJs(backDuibi);
      }else{
        consoles+=getHex("add"," 0个文件")
        console.log(util.getTime() + " " + consoles);
      }
    },100)
  }
  spinner.start();
  spinner.text = getHex("ms","正在检查文件...");
  fileDisplay(rootPath,backFun);
}
//文件遍历方法
function fileDisplay(filePath,backFun) {
  fs.readdir(filePath,(err,datas)=>{
    var filelist = {
      filePath:filePath,
      child:[]
    };
    //遍历读取到的文件列表
    var vueFilesP = [];
    var fileList = [];  //用于排序
    datas.forEach(function(filename,index) {
      //获取当前文件的绝对路径
      var filedir = path.join(filePath, filename);
      fileList.push(filedir)
      //根据文件路径获取文件信息，返回一个fs.Stats对象
      vueFilesP.push(new Promise(function (resolve,reject) {
        let indexs = index;
        fs.stat(filedir,(err,stats)=>{
          var isFile = stats.isFile(); //是文件
          var isDir = stats.isDirectory(); //是文件夹
          if (isFile) {
            if (isVueFile(filedir) || isLessFile(filedir)) {
              filelist.child.push({
                filedir,
                fileName:path.basename(filedir),
              });
              backFun();
            }
          }
          if (isDir) {
            fileDisplay(filedir,backFun); //递归，如果是文件夹，就继续遍历该文件夹下面的文件
          }
          resolve();
        });
      }));
    });
    Promise.all(vueFilesP).then(function () {
      if(filelist.child.length){
        filelist.child.sort(function(a,b){
          let aIndex = fileList.findIndex(num=>num == a.filedir);
          let bIndex = fileList.findIndex(num=>num == b.filedir);
          return aIndex - bIndex;
        })
        newZongList.push(filelist)
      }
      backFun();
    })
  });
}
//给某文件添加监听
function addFileEvent (filedir) {
  var fswatch = fs.watch(filedir,{recursive:true});
  let throttleFun = lodash.throttle(function (event,filename) {
      let filePathName = path.join(filedir,filename);
      let fileWenjianjia = path.dirname(filePathName);
      let fileName = path.basename(filePathName);
      // let isExist = fs.existsSync(filePathName);
      // console.log(isExist)
      if("rename" == event){  //添加、删除文件
        checkProjeck(rootPath);
        return;
      }
      if(!(isVueFile(filePathName) || isLessFile(filePathName)))return;
      if(event != 'change')return;
      let index = zongFileList.findIndex(num=>num.filePath == fileWenjianjia);
      if(~index){
        let fileIndex = zongFileList[index].child.findIndex(num=>num.fileName == fileName);
        if(~fileIndex){
          let consoles0 = util.getTime() + " ";
          let consoles1 = getHex("ms","检测到文件 ");
          let consoles2 = getHex("file",getFilePathXD(filePathName));
          let consoles3 = getHex("ms"," 变化");
          console.log(consoles0+consoles1+consoles2+consoles3)
          changeComJs(index,fileIndex);
        }
      }
    },1000,{
      leading:true,
      trailing:false
    })
  fswatch.on("change",throttleFun)
}
//比较目录、添加、删除监听
function duibiFiles (backFun) {
  let addnumber= 0;
  let removenumber = 0;
  for(let i=0;i<newZongList.length;i++){
    let {filePath,child} = newZongList[i];
    let index = zongFileList.findIndex(num=>num.filePath == filePath);
    if(~index){ //文件夹存在
      let {filePath:filePathOld,child:childOld} = zongFileList[index];
      //删除已删除文件
      for(let j=0;j<childOld.length;){
        let indexNew = child.findIndex(nums=>nums.fileName == childOld[j].fileName);
        if(!~indexNew){ //不存在（已删除）
          deleteZongList.push({filePath:filePathOld,fileName:childOld[j].fileName});
          removenumber++;
          let filePathss = getFilePathXD(path.join(filePathOld,childOld[j].fileName));
          backFun(util.getTime() + " " + getHex("delete","删除文件："+filePathss)+getHex("file",filePathss));
          zongFileList[index].child.splice(j,1);
          refJs(index);
        }else{  //存在
          j++
        }
      }
      //添加新文件
      let startIndex = 0;
      child.map((num,index1)=>{
        let fileIndex = childOld.findIndex(numc=>numc.fileName == num.fileName)
        if(!~fileIndex){ //文件不存在，说明为新增文件
          addZongList.push({filePath:filePath,fileName:num.fileName});
          backFun(util.getTime() + " " + getHex("add","新增文件：")+getHex("file",getFilePathXD(path.join(filePath,num.fileName))));
          zongFileList[index].child.splice(index1,0,{
            fileName:num.fileName
          });
          // addFileEvent(filePath,num.fileName);
        }
      })

    }else{ //文件夹不存在
      zongFileList.push({
        filePath,
        child:child.map(num=>{
          addZongList.push({filePath:filePath,fileName:num.fileName});
          backFun(util.getTime() + " " + getHex("add","新增文件：")+getHex("file",getFilePathXD(path.join(filePath,num.fileName))) );
          // addFileEvent(filePath,num.fileName);
          return {
            fileName:num.fileName
          }
        })
      });
    }
  }
  //检查有没有删除的文件夹
  for(let i=0;i<zongFileList.length;){
    let {filePath,child} = zongFileList[i];
    let index = newZongList.findIndex(num=>num.filePath == filePath);
    if(~index){
      i++
    }else{
      zongFileList[i].child = [];
      refJs(i);
      backFun(util.getTime() + " " + getHex("delete","删文件夹：") + getHex("file",getFilePathXD(filePath)) );
      deleteZongList.push(...new Array(child.length).fill({filePath:filePath}));
      zongFileList.splice(i,1);
    }
  }
}
//群体加载
function createComAllJs (backFun) {
  spinner.start();
  let zongNumber = addZongList.length;
  let jindu = 1;//当前进度
  //处理新增
  let addAll = [];
  let addFilePath = {};
  for(let i=0;i<addZongList.length;i++){
    let {filePath,fileName} = addZongList[i];
    let filePaths = path.join(filePath,fileName);
    let ps = new Promise(function (resolve, reject) {
      createComJs(filePath,fileName,(err, result)=>{
        spinner.start();
        spinner.text = jindu+"/"+zongNumber+" 正在编译："+filePaths;
        jindu++;
        if(err){
          spinner.stop();
          console.log(util.getTime() + " "+ getHex("ms","编译报错（已跳过）")+ getHex("file",getFilePathXD(filePaths))+ getHex("ms","：")+ getHex("delete",err));
        }else{  //成功获取到内容
          let filePathIndex = zongFileList.findIndex(num=>num.filePath == filePath);
          if(~filePathIndex){
            let fileNameIndex = zongFileList[filePathIndex].child.findIndex(num=>num.fileName == fileName);
            if(~fileNameIndex){
              zongFileList[filePathIndex].child[fileNameIndex].content = result;

            }
          }
        }
        resolve()
      });
    })
    addAll.push(ps);
  }
  Promise.all(addAll).then(() => {
    spinner.stop();
    // console.log(JSON.stringify(zongFileList))
    refJs();
    console.log(util.getTime() + " " + getHex("add","编译完成==================="));
  });
}
// 文件变化
function changeComJs (filePathIndex,fileNameIndex) {
  let filePath = zongFileList[filePathIndex].filePath;
  let fileName = zongFileList[filePathIndex].child[fileNameIndex].fileName;
  createComJs(filePath,fileName,(err, result)=>{
    if(err){
      console.log(util.getTime() + " "+ getHex("ms","编译报错（已跳过）")+ getHex("file",getFilePathXD(path.join(filePath,fileName)))+ getHex("ms","：")+ getHex("delete",err));
    }else{
      zongFileList[filePathIndex].child[fileNameIndex].content = result;
      refJs(filePathIndex);
    }
    console.log(util.getTime() + " " + getHex("add","编译完成==================="));
  })
}
function createComJs (filePath,fileName,backFun) {
  let filePaths = path.join(filePath,fileName);
  if(isVueFile(filePaths)){
    vueLoader.init(filePaths,(err,datas)=>{
      if(err){
        backFun(err);
      }else{
        backFun(false,datas);
      }
    });
  }else if(isLessFile(filePaths)){
    let datas = fs.readFileSync(filePaths,"utf-8");
    vueLoader.createCss([{content:datas,attrs:{lang:"less"}}],(err,cssR)=>{
      if(err){
        backFun(err);
      }else{
        let zongOut = `${(cssR||'').trim()}`;
        backFun(false,zongOut);
      }
    })
  }

}
// 生成js,index为下标
function refJs (index) {
  let addList = addZongList;
  for(let i=0;i<zongFileList.length;i++){
    let {child,filePath} = zongFileList[i];
    if(index===undefined&&~addList.findIndex(num=>num.filePath==filePath) || index===i){
      let contentJS = [];
      let contentCSS = [];
      child.map(num=>{
        let filePaths = path.join(filePath,num.fileName);
        if(isVueFile(filePaths)){
          contentJS.push(num.content);
        }else if(isLessFile(filePaths)){
          contentCSS.push(num.content)
        }
      })
      let function1 = `/*
  1、此文件由自制NPM插件（wp-vuetojs）编译而成
  2、【wp-vuetojs】插件经npm安装（npm install -g wp-vuetojs）后，在指定目录运行【vuetojs】命令，可递归将目录下所有特定格式vue文件转化为一个js至本目录
  2、本文件不建议编辑，因为在【wp-vuetojs】运行后会监听目录下 新增、删除vue文件及代码，从而自动编译（报错会打印错误信息）
  3、vue文件名即为组件名，有大写是调用需使用(-小写字母)替代，因为html不区分大小写
  4、被同一html文件引用的组件之间，可以互相调用
  5、更多请关注 https://www.npmjs.com/package/wp-vuetojs
*/

function vuetojsAddClass(content) {
  let styleElement = document.getElementById("styleSelf");
  if (!styleElement) {
    styleElement = document.createElement("style");
    styleElement.type = "text/css";
    styleElement.id = "styleSelf";
    document.head.appendChild(styleElement);
  }
  let oldStyle = styleElement.innerText;
  styleElement.innerHTML = oldStyle+"\\n"+content+"\\n";
}`;
      if(contentJS.length){
        let zongContentJs =[function1,...contentJS].join("\n");
        fs.writeFile(path.join(filePath,"avueComponent.js"),zongContentJs,'utf-8',()=>{

        })
      }else{
        fs.unlink(path.join(filePath,"avueComponent.js"), (err) => {
        });
      }
      let function2 = `/*
  1、此文件由自制NPM插件（wp-vuetojs）编译而成
  2、【wp-vuetojs】插件经npm安装（npm install -g wp-vuetojs）后，在指定目录运行【vuetojs】命令，可递归将目录下所有特定格式less文件转化为一个css至本目录
  2、本文件不建议编辑，因为在【wp-vuetojs】运行后会监听目录下 新增、删除less文件及代码，从而自动编译（报错会打印错误信息）
  5、更多请关注 https://www.npmjs.com/package/wp-vuetojs
*/
`;
      if(contentCSS.length){
        let zongContentCss =[function2,...contentCSS].join("\n");
        fs.writeFile(path.join(filePath,"avueComponent.css"),zongContentCss,'utf-8',()=>{

        })
      }else{
        fs.unlink(path.join(filePath,"avueComponent.css"), (err) => {
        });
      }

    }
  }
}
//获取文件相对路径
function getFilePathXD(path){
  return path.replace(rootPath,"").replace(/\\/g,"/");
}
//是否为vue文件
function isVueFile (filedir) {
  var extname = path.extname(filedir);
  return extname == ".vue"
}
//是否为less文件
function isLessFile (filedir) {
  var extname = path.extname(filedir);
  return extname == ".less"
}
//获取hex
function getHex(type,str){
  return chalk.hex(fontColor[type]).bold(str);
}
