/*
  1、此文件由自制NPM插件（wp-vuetojs）编译而成
  2、【wp-vuetojs】插件经npm安装（npm install -g wp-vuetojs）后，在指定目录运行【vuetojs】命令，可递归将目录下所有特定格式vue文件转化为一个js至本目录
  2、本文件不建议编辑，因为在【wp-vuetojs】运行后会监听目录下 新增、删除vue文件及代码，从而自动编译（报错会打印错误信息）
  3、vue文件名即为组件名，有大写是调用需使用(-小写字母)替代，因为html不区分大小写
  4、被同一html文件引用的组件之间，可以互相调用
  5、更多请关注 https://www.npmjs.com/package/wp-vuetojs
*/

function vuetojsAddClass(content) {
  let styleElement = document.getElementById("styleSelf");
  if (!styleElement) {
    styleElement = document.createElement("style");
    styleElement.type = "text/css";
    styleElement.id = "styleSelf";
    document.head.appendChild(styleElement);
  }
  let oldStyle = styleElement.innerText;
  styleElement.innerHTML = oldStyle+"\n"+content+"\n";
}
Vue.component("form-com-select-image", {
template:`<div data-form-com-select-image  class="main-content">
  <!-- <el-input class="input" @input="input" @click.native="clickInput" :value="value"></el-input> -->
  <div class="showImage" ref="imageContent" :class="{nullValue:!value}">
    <el-image class="imageDIv" :src="\`\${value}/sss\`" @load="change">
      <div slot="placeholder" class="image-slot">
        <i class="el-icon-loading"></i>&nbsp;&nbsp;加载中...
      </div>
    </el-image>
    <div class="ctrlDiv" @click="handleTrigger">
      <div class="clear" @click.stop="clear" v-show="value">
        <i class="el-icon-close"></i>
      </div>
      {{tip}}
    </div>
  </div>
  <el-dialog
    title="选择图片" append-to-body top="8vh"
    :visible.sync="dialogVisible"
    width="90%">
    <div style="height: calc(84vh - 110px);">
      <page-com-image-config ref="selectImageModal" :value="value" @select="selectImage"></page-com-image-config>
    </div>
  </el-dialog>
</div>`,
    props:{
      value:{
        type:String
      },
      tip:{
        type:String,
        default:"点击选择图片"
      }
    },
    data(){
      return {
        dialogVisible:false,
        timeOut:null,
        // scrollC:null
      }
    },
    // mounted() {
    //   this.scrollC = this.$refs.imageContent;
    // },
    methods:{
      input(value){
        this.$emit("input",value)
      },
      change(){
        if(this.timeOut){
          clearTimeout(this.timeOut);
        }
        this.timeOut = setTimeout(()=>{
          this.$emit("change",this.value)
        },20)
      },
      clear(){
        this.$emit("input","")
        this.change();
      },
      handleTrigger(){
        this.dialogVisible = true;
        this.$nextTick(()=>{
          this.$refs.selectImageModal.queryMenu();
        })
      },
      selectImage(value){
        this.$emit("input",value)
        this.change();
        this.dialogVisible = false;
      },
      clickInput(){
        // if(this.hideImage){
        //   this.handleTrigger();
        // }
      }
    }
  });
vuetojsAddClass(`[data-form-com-select-image].main-content .showImage {
  margin-top: 5px;
  width: 100%;
  height: 100px;
  position: relative;
  border: 1px solid #68706c;
}
[data-form-com-select-image].main-content .showImage .imageDIv {
  width: 100%;
  height: 100%;
}
[data-form-com-select-image].main-content .showImage .ctrlDiv {
  display: none;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  background: rgba(0, 0, 0, 0.4);
}
[data-form-com-select-image].main-content .showImage .ctrlDiv .clear {
  position: absolute;
  top: 5px;
  right: 5px;
  color: red;
}
[data-form-com-select-image].main-content .showImage:hover .ctrlDiv,
[data-form-com-select-image].main-content .showImage.nullValue .ctrlDiv {
  display: flex;
}

.image-slot {
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  justify-content: center;
}`)
Vue.component("form-com-table", {
template:`<div data-form-com-table  class="form-table">
  <div v-for="(item,index) in configlistGroup" :key="index">
    <div class="config-manager-head" @click="expandFunc(item.title,item.isShow)">
      {{ item.title}}
      <div class="iconDiv" >
        <i v-show="item.isShow" class="glyphicon glyphicon-resize-small"></i>
        <i v-show="!item.isShow" class="glyphicon glyphicon-resize-full"></i>
      </div>
    </div>
    <div v-show="item.isShow" class="" style="width: 100%;height: auto;">
      <div v-for="(ite ,ind) in item.children" class="datav-gui" :key="ind">
        <div class="gui-controller gui-field-controller gui-controller-level-0">
          <form-com-row :row="ite" :value="jsondatacom[ite.key]" :hideLabel="false" @change="onChange" @input="(value)=>{inputChange(value,ite.key)}"></form-com-row>
          <!-- <form-com-row :row="ite" :hideLabel="false" v-model="configlistGroup[index].children[ind].varVal"></form-com-row> -->
          <div style="width: 40px; display: flex; justify-content: center; align-items: center;cursor: pointer;" title="还原默认值">
            <i class="el-icon-refresh-left" @click="reback(ite.key)"></i>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>`,
  props: ["configlist", "value"],
  data() {
    return {
      isCloseArr: []
    }
  },
  computed: {
    configlistGroup: function () {
      let resArr = []
      let data = this.configlist;
      if (data) {
        let tempArr = []
        data.forEach(item => {
          tempArr.push(item.groupName)
        })
        let groupArr = [...new Set(tempArr)]
        groupArr.forEach(ite => {
          let children = []
          data.forEach(item => {
            if (item.groupName == ite) {
              children.push({ ...item })
            }
          })
          resArr.push({
            title: ite,
            isShow: !~this.isCloseArr.indexOf(ite),
            children
          })
        })
      }
      return resArr

    },
    jsondatacom: function () {
      var jsonNew = {}
      let data = this.configlist;
      data.forEach(item => {
        var key = item.key
        var jsonVal = this.value[key]
        // if (jsonVal === undefined) {
        if (this.value.hasOwnProperty(key)) {
          jsonNew[key] = jsonVal
        } else {
          jsonNew[key] = item.value
        }
      })
      return jsonNew
    },

  },
  methods: {
    expandFunc(title, isShow) {
      if (!isShow) {
        this.isCloseArr = this.isCloseArr.filter(num => num != title)
      } else {
        this.isCloseArr.push(title)
      }

    },
    inputChange(value, key) {
      var jsonNew = {
        ...this.jsondatacom,
        [key]: value
      }
      this.$emit('input', jsonNew)
      // console.log("input", value, key)
    },
    onChange() { //更改完成事件
      this.$emit('change', this.value)
    },
    reback(key) {
      var currObj = this.configlist.find(num => num.key == key)
      var jsonNew = {
        ...this.jsondatacom,
        [key]: currObj.value
      }
      this.$emit('input', jsonNew)
      this.$emit('change', this.jsondatacom)
    },
  }
});
vuetojsAddClass(`[data-form-com-table].form-table {
  width: 100%;
  height: 100%;
  overflow: auto;
  text-align: initial;
  background: #1b1f25;
}
[data-form-com-table].form-table .config-manager-head {
  width: 100%;
  height: 30px;
  line-height: 30px;
  background: #2e343c;
  color: #bcc9d4;
  text-align: center;
  user-select: none;
  font-size: 12px;
  margin-bottom: 6px;
}
[data-form-com-table].form-table .config-manager-head .iconDiv {
  float: right;
  top: 0px;
  right: 15px;
  cursor: pointer;
  position: relative;
  height: 30px;
  display: flex;
  align-items: center;
}
[data-form-com-table].form-table .gui-field-container {
  width: calc(100% - 40px);
  min-width: 130px;
}
[data-form-com-table].form-table .gui-field-container .field-real {
  width: 100%;
}
[data-form-com-table].form-table .datav-gui {
  position: relative;
  font-style: normal;
  width: 100%;
  -webkit-font-smoothing: antialiased;
  user-select: none;
  moz-user-select: -moz-none;
  -moz-user-select: none;
  -o-user-select: none;
  -khtml-user-select: none;
  -webkit-user-select: none;
  -ms-user-select: none;
  font-size: 12px;
  color: #bcc9d4;
  box-sizing: border-box;
  background: #1b1f25;
}
[data-form-com-table].form-table .datav-gui .gui-field-controller .gui-field-name {
  padding-right: 5px;
  padding-top: 4px;
  line-height: 24px;
  width: 85px;
}
[data-form-com-table].form-table .datav-gui .gui-field-controller {
  padding: 0px 8px 5px 8px;
  position: relative;
  color: #bcc9d4;
  display: flex;
  flex-flow: row nowrap;
  min-height: 24px;
}
[data-form-com-table].form-table .datav-gui .gui-controller-level-0.gui-field-controller {
  padding: 0px 8px 5px 8px;
}
[data-form-com-table].form-table .datav-gui input,
[data-form-com-table].form-table select {
  background: #0e1013;
  padding-left: 4px;
}
[data-form-com-table].form-table .yemianSet input[type="text"] {
  display: inline-block;
  box-sizing: border-box;
  color: #bcc9d4;
  vertical-align: top;
}
[data-form-com-table].form-table .data-attr-table {
  width: 100%;
  color: #bcc9d4;
  text-align: left;
}
[data-form-com-table].form-table .data-attr-table .table-head {
  font-size: 0;
}
[data-form-com-table].form-table .data-attr-table .table-head {
  display: block;
  line-height: 40px;
  height: 40px;
  width: 100%;
  border-bottom: 1px solid #282f3a;
}`)
Vue.component("page-com-image-config", {
template:`<div data-page-com-image-config  class="main-image-config">
  <div class="image-left">
    <div class="image-left-head">
      <div class="image-left-head-icon">
        <i class="el-icon-menu"></i>
        我的素材
      </div>
      <div class="image-left-head-button">
        <el-button type="primary" icon="el-icon-folder-add" size="small">添加分组</el-button>
      </div>
    </div>
    <div class="image-left-content">
      <div class="image-menu-list" :class="{active:menuSelectId == num.mtr_id}"
          v-for="(num,index) in menuList" @click="clickMenu(num.mtr_id)">
        {{num.mtr_name}}
      </div>
    </div>
  </div>
  <div class="image-right">
    <div class="image-right-head">
      <div class="blueColor">
        <i class="el-icon-minus" style="transform: rotate(90deg);font-size: 20px;"></i>
        {{selectMenuNode.mtr_name}}&nbsp;&nbsp;{{imageList.length}}
      </div>
      个
    </div>
    <div class="image-right-content">
      <div class="image-card image-add" @click="updateImages">
        <div class="imageDIv" style="">
          <i class="el-icon-plus" style="font-size: 20px;display: block;margin-bottom: 10px;"></i>
          <div class="" style="letter-spacing: 2px;">
            添加图片
          </div>
        </div>
      </div>
      <div class="image-card" @click="selected(num)" :class="{active:value == baseUrl+num.mtr_id,loading:!num.isLoad}"
            v-for="(num,index) in imageList">
        <el-image class="imageDIv" @load="loadImage(num)" :src="baseUrl+num.mtr_id" fit="scale-down" lazy>
          <div slot="placeholder" class="image-slot">
            <i class="el-icon-loading"></i>&nbsp;&nbsp;加载中...
          </div>
          <div slot="error" class="image-slot">
            <i class="el-icon-picture-outline"></i>&nbsp;&nbsp;加载失败
          </div>
        </el-image>
      </div>
    </div>
  </div>
  <el-dialog
    title="上传图片" append-to-body width="60%"
    :visible.sync="updateImage">
    <div style="">
      <div style="height: 300px;overflow-y: auto;">
        <el-upload v-if="updateImage"
          ref="upload" multiple
          :auto-upload="false">
          <el-button size="small" type="primary">选择文件</el-button>
          <el-button size="small" type="success" @click.stop="submitUpload">上传到服务器</el-button>
        </el-upload>
      </div>
    </div>
  </el-dialog>
</div>`,
    props:["value"],
    data(){
      return {
        updateImage:false,
        menuList:[],
        menuSelectId:"",
        imageList:[],
        baseUrl:"/SMP/sml/file/show/material?mtrId=",
        fileList:[],
      }
    },
    computed:{
      selectMenuNode(){
        return this.menuList.find(num=>num.mtr_id == this.menuSelectId) || {};
      }
    },
    methods:{
      queryMenu(isSelectFisrt){
        commonAjaxCom("/sml/query/smp-re-material-enum-query","","get",true,(data)=> {
          if(data&&data.success){
            this.menuList = data.data;
            if(isSelectFisrt && this.menuList.length){
              this.clickMenu(this.menuList[0].mtr_id)
            }
          }
        })
      },
      clickMenu(id){
        this.menuSelectId = id;
        this.queryRightImageList();
      },
      selected({mtr_id,isLoad}){
        if(!isLoad)return;
        this.$emit("select",this.baseUrl+mtr_id)
      },
      loadImage({mtr_id}){
        let index = this.imageList.findIndex(num=>num.mtr_id == mtr_id);
        if(~index){
          this.$set(this.imageList[index],"isLoad",true)
        }
      },
      queryRightImageList(){
        commonAjaxCom("/sml/query/smp-re-material-query",{
          mtrPId:this.menuSelectId
        },"get",true,(data)=> {
          if(data&&data.success){
            this.imageList = data.data;
          }
        })
      },
      // 上传文件
      updateImages(){
        this.updateImage = true;
        this.fileList = [];
      },
      submitUpload() {
        var formFile = new FormData();
        let updateList = this.$refs.upload.uploadFiles;
        formFile.append(`mtrId`,this.menuSelectId);
        if(!updateList.length){
          this.$message({
            message: '请选择至少一个文件上传！',
            type: 'warning'
          });
          return;
        }
        for (var i = 0; i < updateList.length; i++) {
          let {raw} = updateList[i];
          formFile.append(`file${i+1}`,raw);
        }
        commonAjaxUpdate("/sml/file/uploads/material",formFile,"post",true,(data)=>{
          if(data.length){
            this.$message({
              message: `成功上传${data.length}个文件！`,
              type: 'warning'
            });
            this.queryRightImageList();
            this.updateImage = false;
          }
        })
      },
    },
    mounted() {
      this.queryMenu(true);
    }
  });
vuetojsAddClass(`.image-slot {
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  justify-content: center;
}

[data-page-com-image-config].main-image-config {
  height: 100%;
  display: flex;
}
[data-page-com-image-config].main-image-config .image-left {
  width: 265px;
  padding-right: 10px;
  display: flex;
  flex-direction: column;
}
[data-page-com-image-config].main-image-config .image-left .image-left-head {
  height: 50px;
  border-bottom: 1px solid #726969;
  display: flex;
  justify-content: space-between;
  align-items: center;
}
[data-page-com-image-config].main-image-config .image-left .image-left-content {
  padding: 0 10px 10px 0;
  margin-top: 10px;
  overflow-y: auto;
  flex: 1;
}
[data-page-com-image-config].main-image-config .image-left .image-left-content .image-menu-list {
  padding: 5px 10px;
  margin: 3px 0;
  border: 1px solid transparent;
  cursor: pointer;
}
[data-page-com-image-config].main-image-config .image-left .image-left-content .image-menu-list:hover {
  color: #03e6ff;
}
[data-page-com-image-config].main-image-config .image-left .image-left-content .image-menu-list.active {
  background-color: #057d8a;
  color: #fff;
  border-color: #03e6ff;
}
[data-page-com-image-config].main-image-config .image-right {
  flex: 1;
  border-left: 1px solid #726969;
  display: flex;
  padding-left: 10px;
  flex-direction: column;
}
[data-page-com-image-config].main-image-config .image-right .image-right-head {
  height: 50px;
  border-bottom: 1px solid #726969;
  display: flex;
  align-items: center;
  font-size: 16px;
}
[data-page-com-image-config].main-image-config .image-right .image-right-head .blueColor {
  display: flex;
  align-items: center;
  color: #00baff;
  font-size: 16px;
  margin-right: 5px;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content {
  padding: 0 0 10px 10px;
  margin-top: 10px;
  overflow-y: auto;
  flex: 1;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card {
  float: left;
  margin: 20px;
  background-color: #252a2c;
  border: 1px solid #505455;
  position: relative;
  overflow: hidden;
  cursor: pointer;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card .imageDIv {
  width: 220px;
  height: 150px;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card.active {
  border-color: #00baff;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card.loading {
  cursor: no-drop;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card.image-add {
  border: 1px solid #00baff;
  font-size: 14px;
  color: #8eeeff;
  background-image: linear-gradient(-90deg, rgba(0, 222, 255, 0.39) 0, rgba(0, 174, 255, 0.19) 100%);
  box-shadow: 0 0 10px 0 rgba(55, 224, 255, 0.3);
  cursor: pointer;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card.image-add .imageDIv {
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}
[data-page-com-image-config].main-image-config .image-right .image-right-content .image-card.image-add:hover {
  background-image: linear-gradient(-90deg, rgba(0, 222, 255, 0.6) 0, rgba(0, 174, 255, 0.19) 100%);
  box-shadow: 0 0 20px 0 rgba(55, 224, 255, 0.3);
}`)
Vue.component("test", {
template:`<div data-test  class="jjj">
sssssss
  </div>`,
    data(){
      return {}
    }
  });
vuetojsAddClass(`[data-test].jjj {
  color: red;
  font-size: 12px;
}
[data-test].jjj.bbb {
  display: block;
}
[data-test].jjj:hover {
  color: aliceblue;
}`)