/*
  1、此文件由自制NPM插件（wp-vuetojs）编译而成
  2、【wp-vuetojs】插件经npm安装（npm install -g wp-vuetojs）后，在指定目录运行【vuetojs】命令，可递归将目录下所有特定格式vue文件转化为一个js至本目录
  2、本文件不建议编辑，因为在【wp-vuetojs】运行后会监听目录下 新增、删除vue文件及代码，从而自动编译（报错会打印错误信息）
  3、vue文件名即为组件名，有大写是调用需使用(-小写字母)替代，因为html不区分大小写
  4、被同一html文件引用的组件之间，可以互相调用
  5、更多请关注 https://www.npmjs.com/package/wp-vuetojs
*/

function vuetojsAddClass(content) {
  let styleElement = document.getElementById("styleSelf");
  if (!styleElement) {
    styleElement = document.createElement("style");
    styleElement.type = "text/css";
    styleElement.id = "styleSelf";
    document.head.appendChild(styleElement);
  }
  let oldStyle = styleElement.innerText;
  styleElement.innerHTML = oldStyle+"\n"+content+"\n";
}
Vue.component("form-com-select-image", {
template:`<div data-form-com-select-image  class="main-content">
  <!-- <el-input class="input" @input="input" @click.native="clickInput" :value="value"></el-input> -->
  <div class="showImage" ref="imageContent" :class="{nullValue:!value}">
    <el-image class="imageDIv" :src="value" @load="change">
      <div slot="placeholder" class="image-slot">
        <i class="el-icon-loading"></i>&nbsp;&nbsp;加载中...
      </div>
    </el-image>
    <div class="ctrlDiv" @click="handleTrigger">
      <div class="clear" @click.stop="clear" v-show="value">
        <i class="el-icon-close"></i>
      </div>
      {{tip}}
    </div>
  </div>
  <el-dialog
    title="选择图片" append-to-body top="8vh"
    :visible.sync="dialogVisible"
    width="90%">
    <div style="height: calc(84vh - 110px);">
      <page-com-image-config ref="selectImageModal" :value="value" @select="selectImage"></page-com-image-config>
    </div>
  </el-dialog>
</div>`,
    props:{
      value:{
        type:String
      },
      tip:{
        type:String,
        default:"点击选择图片"
      }
    },
    data(){
      return {
        dialogVisible:false,
        timeOut:null,
        // scrollC:null
      }
    },
    // mounted() {
    //   this.scrollC = this.$refs.imageContent;
    // },
    methods:{
      input(value){
        this.$emit("input",value)
      },
      change(){
        if(this.timeOut){
          clearTimeout(this.timeOut);
        }
        this.timeOut = setTimeout(()=>{
          this.$emit("change",this.value)
        },20)
      },
      clear(){
        this.$emit("input","")
        this.change();
      },
      handleTrigger(){
        this.dialogVisible = true;
        this.$nextTick(()=>{
          this.$refs.selectImageModal.queryMenu();
        })
      },
      selectImage(value){
        this.$emit("input",value)
        this.change();
        this.dialogVisible = false;
      },
      clickInput(){
        // if(this.hideImage){
        //   this.handleTrigger();
        // }
      }
    }
  });
vuetojsAddClass(`[data-form-com-select-image].main-content .showImage {
  margin-top: 5px;
  width: 100%;
  height: 100px;
  position: relative;
  border: 1px solid #68706c;
}
[data-form-com-select-image].main-content .showImage .imageDIv {
  width: 100%;
  height: 100%;
}
[data-form-com-select-image].main-content .showImage .ctrlDiv {
  display: none;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  background: rgba(0, 0, 0, 0.4);
}
[data-form-com-select-image].main-content .showImage .ctrlDiv .clear {
  position: absolute;
  top: 5px;
  right: 5px;
  color: red;
}
[data-form-com-select-image].main-content .showImage:hover .ctrlDiv,
[data-form-com-select-image].main-content .showImage.nullValue .ctrlDiv {
  display: flex;
}

.image-slot {
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  justify-content: center;
}`)